%bcond_without gfortran
%bcond_without sse2
%bcond_with check

Summary: Fast Fourier Transform library
Name: fftw
Version: 3.2.2
Release: 14%{?dist}
License: GPL
Group: System Environment/Libraries
Source: ftp://fftw.org/pub/fftw/%{name}-%{version}.tar.gz
URL: http://www.fftw.org/
BuildRoot: %{_tmppath}/%{name}-root
#BuildRequires: ocaml, autoconf, automake, libtool
%{?with_gfortran:BuildRequires: gcc-gfortran}
%{!?with_gfortran:BuildRequires: gcc-g77}
Requires: /sbin/ldconfig
Provides: fftw3 = %{evr}
Obsoletes: fftw3 < %{evr}

%description
FFTW is a C subroutine library for computing the Discrete Fourier Transform
(DFT) in one or more dimensions, of both real and complex data, and of
arbitrary input size. We believe that FFTW, which is free software, should
become the FFT library of choice for most applications. Our benchmarks,
performed on on a variety of platforms, show that FFTW's performance is
typically superior to that of other publicly available FFT software.


%package devel
Summary: Headers, libraries and docs for the FFTW library.
Group: Development/Libraries
Requires: %{name} = %{eversion}
Provides: fftw3-devel = %{evr}
Obsoletes: fftw3-devel < %{evr}

%description devel
FFTW is a C subroutine library for computing the Discrete Fourier Transform
(DFT) in one or more dimensions, of both real and complex data, and of
arbitrary input size. We believe that FFTW, which is free software, should
become the FFT library of choice for most applications. Our benchmarks,
performed on on a variety of platforms, show that FFTW's performance is
typically superior to that of other publicly available FFT software.

This package contains header files and development libraries needed to
develop programs using the FFTW fast Fourier transform library.


%prep
%setup -q

%build
mkdir double single long_double

cd double
ln -s ../configure .
./configure --prefix=%{_prefix} --libdir=%{_libdir} \
	--enable-portable-binary \
%ifarch %ix86 x86_64
	--with-gcc-arch=i686 \
	%{?with_sse2:--enable-sse2} \
%endif
	--enable-shared --enable-threads
make %{?_smp_mflags}

# --enable-k7 is incompatible with --enable-shared
cd ../single
ln -s ../configure .
./configure --prefix=%{_prefix} --libdir=%{_libdir} \
	--enable-float \
	--enable-portable-binary \
%ifarch %ix86
	--with-gcc-arch=i686 \
	--enable-sse \
%endif
%ifarch x86_64
	--enable-sse \
%endif
	--enable-shared --enable-threads
make %{?_smp_mflags}

cd ../long_double
ln -s ../configure .
./configure --prefix=%{_prefix} --libdir=%{_libdir} \
	--enable-long-double \
	--enable-portable-binary \
%ifarch %ix86
	--with-gcc-arch=i686 \
%endif
	--enable-shared --enable-threads
make %{?_smp_mflags}

cd ..
%if %{with check}
for dir in double single long_double; do
  make -C $dir check
done
%endif

%install
rm -rf %{buildroot}

cd double
make install DESTDIR=%{buildroot}

cd ../single
make install DESTDIR=%{buildroot}

cd ../long_double
make install DESTDIR=%{buildroot}

rm -f %{buildroot}%{_infodir}/dir

%clean
rm -rf %{buildroot}

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%post devel
infofile=%{_infodir}/fftw3.info
if [ -f $infofile.gz ]; then infofile=$infofile.gz; fi
/sbin/install-info $infofile %{_infodir}/dir

%preun devel
if [ $1 = 0 ]; then
  infofile=%{_infodir}/fftw3.info
  if [ -f $infofile.gz ]; then infofile=$infofile.gz; fi
  /sbin/install-info --del $infofile %{_infodir}/dir
fi

%files
%defattr(-,root,root,-)
%doc AUTHORS COPYING COPYRIGHT ChangeLog NEWS README* TODO
%{_libdir}/*.so.*
%{_bindir}/fftw*-wisdom
%{_bindir}/fftw-wisdom-to-conf
%{_mandir}/man1/fftw*-wisdom.1*
%{_mandir}/man1/fftw-wisdom-to-conf.1*

%files devel
%defattr(-,root,root,-)
%doc README TODO NEWS COPYING COPYRIGHT AUTHORS CONVENTIONS
%doc doc/FAQ/fftw-faq.html doc/FAQ/fftw-faq.ascii doc/html doc/fftw3.pdf
%{_includedir}/*
%{_libdir}/*.a
%{_libdir}/*.la
%{_libdir}/*.so
%{_libdir}/pkgconfig/fftw3*.pc
%{_infodir}/fftw3.info*

%changelog
* Sun Aug  9 2009 Axel Thimm <Axel.Thimm@ATrpms.net> - 3.2.2-13
- Update to 3.2.2.

* Fri Jul  7 2006 Axel Thimm <Axel.Thimm@ATrpms.net> - 3.1.2-11
- Update to 3.1.2.

* Sun Jan 29 2006 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 3.1 final.

* Sat Jan  7 2006 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 3.1-beta1.

* Thu Oct 16 2003 Axel Thimm <Axel.Thimm@ATrpms.net>
- Updated to 3.0.1.

* Mon Mar 31 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 2.1.5.
- Rebuilt for Red Hat Linux 9.

* Tue Mar 18 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 2.1.4.
- Exclude .la files.

* Tue Oct 22 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Removed the original single/double build to be "compatible" with the
  gstreamer build :-/

* Mon Oct 21 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Initial RPM release.

